import { EventDefinition, HttpClient } from '@wix/sdk-types';
import { WixDataItem, WixDataOptions, WixDataQueryReferencedOptions, WixDataReadOptions, WixDataReadWithProjectionOptions, WixDataUpdateOptions, DataItemCreatedEnvelope, DataItemUpdatedEnvelope, Environment } from './data-v2-data-item-items.universal';
export declare const __metadata: {
    PACKAGE_NAME: string;
};
export declare function withEnvironment(httpClient: HttpClient): (environment: Environment) => import("@wix/wix-data-items-common").WixDataApi;
export declare function insert(httpClient: HttpClient): (dataCollectionId: string, dataItem: Partial<WixDataItem>, options?: WixDataUpdateOptions) => Promise<WixDataItem>;
export declare function update(httpClient: HttpClient): (dataCollectionId: string, data: WixDataItem, options?: WixDataUpdateOptions) => Promise<WixDataItem>;
export declare function save(httpClient: HttpClient): (dataCollectionId: string, data: Partial<WixDataItem>, options?: WixDataUpdateOptions) => Promise<WixDataItem>;
export declare function get(httpClient: HttpClient): (dataCollectionId: string, dataItemId: string, options?: WixDataReadWithProjectionOptions) => Promise<WixDataItem | null>;
export declare function remove(httpClient: HttpClient): (dataCollectionId: string, dataItemId: string, options?: WixDataOptions) => Promise<WixDataItem | null>;
export declare function truncate(httpClient: HttpClient): (dataCollectionId: string) => Promise<void>;
export declare function bulkInsert(httpClient: HttpClient): (dataCollectionId: string, items: Partial<WixDataItem>[], options?: WixDataOptions) => Promise<import("@wix/wix-data-items-common").WixDataBulkResult>;
export declare function bulkUpdate(httpClient: HttpClient): (dataCollectionId: string, items: WixDataItem[], options?: WixDataOptions) => Promise<import("@wix/wix-data-items-common").WixDataBulkResult>;
export declare function bulkSave(httpClient: HttpClient): (dataCollectionId: string, items: Partial<WixDataItem>[], options?: WixDataOptions) => Promise<import("@wix/wix-data-items-common").WixDataBulkResult>;
export declare function bulkRemove(httpClient: HttpClient): (dataCollectionId: string, itemIds: string[], options?: WixDataOptions) => Promise<import("@wix/wix-data-items-common").WixDataBulkResult>;
export declare function isReferenced(httpClient: HttpClient): (dataCollectionId: string, propertyName: string, referringItem: WixDataItem | string, referencedItem: WixDataItem | string, options?: WixDataReadOptions) => Promise<boolean>;
export declare function insertReference(httpClient: HttpClient): (dataCollectionId: string, propertyName: string, referringItem: WixDataItem | string, referencedItem: WixDataItem | string | WixDataItem[] | string[], options?: WixDataOptions) => Promise<void>;
export declare function removeReference(httpClient: HttpClient): (dataCollectionId: string, propertyName: string, referringItem: WixDataItem | string, referencedItem: WixDataItem | string | WixDataItem[] | string[], options?: WixDataOptions) => Promise<void>;
export declare function replaceReferences(httpClient: HttpClient): (dataCollectionId: string, propertyName: string, referringItem: WixDataItem | string, referencedItem: WixDataItem | string | WixDataItem[] | string[], options?: WixDataOptions) => Promise<void>;
export declare function query(httpClient: HttpClient): (dataCollectionId: string) => import("@wix/wix-data-items-common").WixDataQuery;
export declare function search(httpClient: HttpClient): (dataCollectionId: string) => import("@wix/wix-data-items-common").WixDataSearch;
export declare function patch(httpClient: HttpClient): (dataCollectionId: string, itemId: string) => import("@wix/wix-data-items-common").WixDataPatch;
export declare function bulkPatch(httpClient: HttpClient): (dataCollectionId: string, itemIds: string[]) => import("@wix/wix-data-items-common").WixDataBulkPatch;
export declare function aggregate(httpClient: HttpClient): (dataCollectionId: string) => import("@wix/wix-data-items-common").WixDataAggregate;
export declare function queryReferenced(httpClient: HttpClient): (dataCollectionId: string, holdingItem: WixDataItem | string, relationshipAttribute: string, options?: WixDataQueryReferencedOptions) => Promise<import("@wix/wix-data-items-common").WixDataResult<WixDataItem>>;
export declare function filter(httpClient: HttpClient): () => import("@wix/wix-data-items-common").WixDataFilter;
export declare const onDataItemCreated: EventDefinition<DataItemCreatedEnvelope, "wix.data.v2.data_item_created">;
export declare const onDataItemUpdated: EventDefinition<DataItemUpdatedEnvelope, "wix.data.v2.data_item_updated">;
export declare const onDataItemDeleted: EventDefinition;
export { WixDataReadOptions, WixDataReadWithProjectionOptions, WixDataOptions, WixDataUpdateOptions, };
export { WixDataItem, WixDataBulkError, WixDataBulkResult, Environment, } from './data-v2-data-item-items.universal';
export * from './data-v2-data-item-items.types';
