import { insert as publicInsert, update as publicUpdate, save as publicSave, get as publicGet, remove as publicRemove, truncate as publicTruncate, bulkInsert as publicBulkInsert, bulkUpdate as publicBulkUpdate, bulkSave as publicBulkSave, bulkRemove as publicBulkRemove, isReferenced as publicIsReferenced, insertReference as publicInsertReference, removeReference as publicRemoveReference, replaceReferences as publicReplaceReferences, query as publicQuery, search as publicSearch, patch as publicPatch, bulkPatch as publicBulkPatch, aggregate as publicAggregate, queryReferenced as publicQueryReferenced, filter as publicFilter, withEnvironment as publicWithEnvironment, onDataItemCreated as publicOnDataItemCreated, onDataItemUpdated as publicOnDataItemUpdated, onDataItemDeleted as publicOnDataItemDeleted } from './data-v2-data-item-items.public';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
export declare const insert: MaybeContext<BuildRESTFunction<typeof publicInsert> & typeof publicInsert>;
export declare const update: MaybeContext<BuildRESTFunction<typeof publicUpdate> & typeof publicUpdate>;
export declare const save: MaybeContext<BuildRESTFunction<typeof publicSave> & typeof publicSave>;
export declare const get: MaybeContext<BuildRESTFunction<typeof publicGet> & typeof publicGet>;
export declare const remove: MaybeContext<BuildRESTFunction<typeof publicRemove> & typeof publicRemove>;
export declare const truncate: MaybeContext<BuildRESTFunction<typeof publicTruncate> & typeof publicTruncate>;
export declare const bulkInsert: MaybeContext<BuildRESTFunction<typeof publicBulkInsert> & typeof publicBulkInsert>;
export declare const bulkUpdate: MaybeContext<BuildRESTFunction<typeof publicBulkUpdate> & typeof publicBulkUpdate>;
export declare const bulkSave: MaybeContext<BuildRESTFunction<typeof publicBulkSave> & typeof publicBulkSave>;
export declare const bulkRemove: MaybeContext<BuildRESTFunction<typeof publicBulkRemove> & typeof publicBulkRemove>;
export declare const isReferenced: MaybeContext<BuildRESTFunction<typeof publicIsReferenced> & typeof publicIsReferenced>;
export declare const insertReference: MaybeContext<BuildRESTFunction<typeof publicInsertReference> & typeof publicInsertReference>;
export declare const removeReference: MaybeContext<BuildRESTFunction<typeof publicRemoveReference> & typeof publicRemoveReference>;
export declare const replaceReferences: MaybeContext<BuildRESTFunction<typeof publicReplaceReferences> & typeof publicReplaceReferences>;
export declare const query: MaybeContext<BuildRESTFunction<typeof publicQuery> & typeof publicQuery>;
export declare const search: MaybeContext<BuildRESTFunction<typeof publicSearch> & typeof publicSearch>;
export declare const patch: MaybeContext<BuildRESTFunction<typeof publicPatch> & typeof publicPatch>;
export declare const bulkPatch: MaybeContext<BuildRESTFunction<typeof publicBulkPatch> & typeof publicBulkPatch>;
export declare const aggregate: MaybeContext<BuildRESTFunction<typeof publicAggregate> & typeof publicAggregate>;
export declare const queryReferenced: MaybeContext<BuildRESTFunction<typeof publicQueryReferenced> & typeof publicQueryReferenced>;
export declare const filter: MaybeContext<BuildRESTFunction<typeof publicFilter> & typeof publicFilter>;
export declare const withEnvironment: MaybeContext<BuildRESTFunction<typeof publicWithEnvironment> & typeof publicWithEnvironment>;
/**
 * Triggered when a data item is inserted.
 */
export declare const onDataItemCreated: ReturnType<typeof createEventModule<typeof publicOnDataItemCreated>>;
/**
 * Triggered when a data item is updated or patched.
 */
export declare const onDataItemUpdated: ReturnType<typeof createEventModule<typeof publicOnDataItemUpdated>>;
/**
 * Triggered when a data item is deleted or truncated.
 */
export declare const onDataItemDeleted: ReturnType<typeof createEventModule<typeof publicOnDataItemDeleted>>;
export { Environment, WixDataReadOptions, WixDataReadWithProjectionOptions, WixDataPatchOptions, WixDataOptions, WixDataUpdateOptions, WixDataItem, WixDataBulkResult, WixDataBulkError, WixDataQuery, WixDataPatch, WixDataAggregate, WixDataFilter, WixDataResult, } from './data-v2-data-item-items.universal';
export * from './data-v2-data-item-items.types';
